(************************************************************************
*    This File is Part of the AHM Triton Tools                          *
*    for Borland Delphi and C++ Builder.                                *
*************************************************************************
* Copyright  1995-2000 Alexander H. Mehlhorn (AHM) and Tritontools.com *
* All Rights reserved.                                                  *
*                                                                       *
*    For more Information contact us at                                 *
*    E-Mail : support@tritontools.com                                   *
*    URL : http://www.tritontools.com                                   *
*                                                                       *
*    AHM is copyright by Alexander H. Mehlhorn                          *
*    All Parts of this Collection were developed,                       *
*    designed and implemented by AHM                                    *
*                                                                       *
*    Under no Circumstances may you distribute this file                *
*    in this or any other format. This File is supplied                 *
*    as Evaluation of Source only. No Delphi Components may be developed*
*    using extracts or subsets of this code without expressed permission*
*    by AHM.                                                            *
*                                                                       *
*************************************************************************)
unit AHMRegFree;
interface
uses classes,DsgnIntf,AHMTAboutDialog,AHMTBevel,AHMTClock,AHMTDice,
     AHMTDigital,AHMTFadingLabel,AHMTImage3D,AHMTLeds,AHMTLogWindow,
     AHMTMenuItemGlyph,AHMTOwnership,AHMTQuickInfo,AHMTRtfFile,AHMTSpeakersound,
     AHMTWinDBListbox,AHMTWinListBox,AHMTWinStringGrid,AHMFreeware,SysUtils;
type
  TAHMAboutFreeComponent = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetValue: string; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

procedure Register;
{$R AHMFreeware.res}
implementation

Procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(TAHMAboutFreeStr),nil,'About',TAHMAboutFreeComponent);
  RegisterComponents('AHM Freeware',[TAHMAboutDialog,TAHMBevel,TAHMClock
                                   ,TAHMDice,TAHMDigital,TAHMFadingLabel,TAHMImage,
                                   TAHMLed,TAHMLogWindow,TAHMMenuItemGlyph,TAHMOwnerShip,
                                   TAHMQuickInfo,TAHMRTFFile,TAHMSpeakersound,TAHMWinDBListbox,
                                   TAHMWinListbox,TAHMWinStringGrid]);
end;


procedure TAHMAboutFreeComponent.Edit;
begin
  BuildFreeDetails;
end;

function TAHMAboutFreeComponent.GetValue: string;
begin
  FmtStr(Result, '(%s)', ['AHM Freeware Components']);
end;

function TAHMAboutFreeComponent.GetAttributes: TPropertyAttributes;
begin
  Result := [paMultiSelect,paDialog,paReadOnly];
end;


end.
