(************************************************************************
*    This File is Part of the AHM Triton Tools                          *
*    for Borland Delphi and C++ Builder.                                *
*************************************************************************
* Copyright  1995-2000 Alexander H. Mehlhorn (AHM) and Tritontools.com *
* All Rights reserved.                                                  *
*                                                                       *
*    For more Information contact us at                                 *
*    E-Mail : support@tritontools.com                                   *
*    URL : http://www.tritontools.com                                   *
*                                                                       *
*    AHM is copyright by Alexander H. Mehlhorn                          *
*    All Parts of this Collection were developed,                       *
*    designed and implemented by AHM                                    *
*                                                                       *
*    Under no Circumstances may you distribute this file                *
*    in this or any other format. This File is supplied                 *
*    as Evaluation of Source only. No Delphi Components may be developed*
*    using extracts or subsets of this code without expressed permission*
*    by AHM.                                                            *
*                                                                       *
*************************************************************************)
unit AHMTImage3D;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  ExtCtrls,AHMFreeware;

type
  TAHMImage = class(TGraphiccontrol)
  private
    FAbout : TAHMAboutFreeStr;
    fbitm,fbitmout : TBitmap;
    fborder : Integer;
    f3dform : Boolean;
    fcenter : boolean;
    fint : Integer;
    procedure Setfbitm(value : Tbitmap);
    procedure Setbuts;
    procedure Setint(value : Integer);
    procedure Setborder(value : integer);
    procedure SetCenter(value : Boolean);
    procedure SetForm(value : Boolean);
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Bitmout : TBitmap read fbitmout write fbitmout;
  published
    Property About : TAHMAboutFreeStr read FAbout write FAbout;
    property Picture : TBitmap read fbitm write setfbitm;
    property Intensity : Integer read fint write SetInt;
    property Borderwidth : Integer read fborder write SetBorder;
    property Center : boolean read fcenter write Setcenter;
    property Border3DIn : Boolean read f3dform write Setform;
    property OnClick;
    Property Align;
    Property Visible;
    Property OnMouseMove;
    Property OnMouseDown;
    Property OnMouseUp;
  end;

implementation

constructor TAHMImage.Create(AOwner: TComponent);
begin
  fbitm:=TBitmap.create;
  fbitmout:=TBitmap.create;
  fborder:=4;
  fint:=70;
  inherited Create(AOwner);
  width:=20;
  Height:=20;
end;

destructor TAHMImage.Destroy;
begin
  fbitm.free;
  fbitmout.free;
  inherited Destroy;
end;


procedure TAHMImage.paint;
begin
  with canvas do
  begin
     if fcenter then Draw((Width div 2)-(fbitmOUT.Width div 2),
    (Height div 2) - (fbitmOUT.Height div 2), fbitmOUT)
    else Draw(0,0, fbitmOUT);
  end;
  inherited paint;
end;

procedure TAHMImage.Setbuts;
var x,y : integer;
    isc : STring;
     T1,T2,T3 : lONGINT;
begin
  isc:='0123456789ABCDEF';
  fbitmout.assign(fbitm);
  if  f3dform then
  begin
  with fbitmout.canvas do
  begin
    for y:=0 to fborder do
    for x:=y to fbitmout.width-y do
    begin
      T1:=GetGvalue(fbitmout.canvas.pixels[x,y])-fint; if t1<0 then t1:=0;
      T2:=GetGvalue(fbitmout.canvas.pixels[x,y])-fint; if t2<0 then t2:=0;
      T3:=GetGvalue(fbitmout.canvas.pixels[x,y])-fint; if t3<0 then t3:=0;
      fbitmout.canvas.pixels[x,y]:=Palettergb(t1,t2,t3);
    end;
    for x:=0 to fborder do
    for y:=x to fbitmout.height-x do
    begin
      T1:=GetGvalue(fbitmout.canvas.pixels[x,y])-fint; if t1<0 then t1:=0;
      T2:=GetGvalue(fbitmout.canvas.pixels[x,y])-fint; if t2<0 then t2:=0;
      T3:=GetGvalue(fbitmout.canvas.pixels[x,y])-fint; if t3<0 then t3:=0;
      fbitmout.canvas.pixels[x,y]:=Palettergb(t1,t2,t3);
    end;
     for y:=0 to fborder do
    for x:=y to fbitmout.width-y do
    begin
      T1:=GetGvalue(fbitmout.canvas.pixels[x,fbitmout.height-y])+fint; if t1>255 then t1:=255;
      T2:=GetGvalue(fbitmout.canvas.pixels[x,fbitmout.height-y])+fint; if t2>255 then t2:=255;
      T3:=GetGvalue(fbitmout.canvas.pixels[x,fbitmout.height-y])+fint; if t3>255 then t3:=255;
      fbitmout.canvas.pixels[x,fbitmout.height-y]:=Palettergb(t1,t2,t3);
    end;
    for x:=0 to fborder do
    for y:=x to fbitmout.height-x do
    begin
      T1:=GetGvalue(fbitmout.canvas.pixels[fbitmout.width-x,y])+fint; if t1>255 then t1:=255;
      T2:=GetGvalue(fbitmout.canvas.pixels[fbitmout.width-x,y])+fint; if t2>255 then t2:=255;
      T3:=GetGvalue(fbitmout.canvas.pixels[fbitmout.width-x,y])+fint; if t3>255 then t3:=255;
      fbitmout.canvas.pixels[fbitmout.width-x,y]:=Palettergb(t1,t2,t3);
    end;
  end;
  end
  else
  with fbitmout.canvas do
  begin
    for y:=0 to fborder do
    for x:=y to fbitmout.width-y do
    begin
      T1:=GetGvalue(fbitmout.canvas.pixels[x,fbitmout.height-y])-fint; if t1<0 then t1:=0;
      T2:=GetGvalue(fbitmout.canvas.pixels[x,fbitmout.height-y])-fint; if t2<0 then t2:=0;
      T3:=GetGvalue(fbitmout.canvas.pixels[x,fbitmout.height-y])-fint; if t3<0 then t3:=0;
      fbitmout.canvas.pixels[x,fbitmout.height-y]:=Palettergb(t1,t2,t3);
    end;
    for x:=0 to fborder do
    for y:=x to fbitmout.height-x do
    begin
      T1:=GetGvalue(fbitmout.canvas.pixels[fbitmout.width-x,y])-fint; if t1<0 then t1:=0;
      T2:=GetGvalue(fbitmout.canvas.pixels[fbitmout.width-x,y])-fint; if t2<0 then t2:=0;
      T3:=GetGvalue(fbitmout.canvas.pixels[fbitmout.width-x,y])-fint; if t3<0 then t3:=0;
      fbitmout.canvas.pixels[fbitmout.width-x,y]:=Palettergb(t1,t2,t3);
    end;
     for y:=0 to fborder do
    for x:=y to fbitmout.width-y do
    begin
      T1:=GetGvalue(fbitmout.canvas.pixels[x,y])+fint; if t1>255 then t1:=255;
      T2:=GetGvalue(fbitmout.canvas.pixels[x,y])+fint; if t2>255 then t2:=255;
      T3:=GetGvalue(fbitmout.canvas.pixels[x,y])+fint; if t3>255 then t3:=255;
      fbitmout.canvas.pixels[x,y]:=Palettergb(t1,t2,t3);
    end;
    for x:=0 to fborder do
    for y:=x to fbitmout.height-x do
    begin
      T1:=GetGvalue(fbitmout.canvas.pixels[x,y])+fint; if t1>255 then t1:=255;
      T2:=GetGvalue(fbitmout.canvas.pixels[x,y])+fint; if t2>255 then t2:=255;
      T3:=GetGvalue(fbitmout.canvas.pixels[x,y])+fint; if t3>255 then t3:=255;
      fbitmout.canvas.pixels[x,y]:=Palettergb(t1,t2,t3);
    end;
  end;
end;


procedure TAHMImage.setfbitm(value : Tbitmap);
begin
  if value <> fbitm then
  begin
    fbitm.assign(value);
    fbitmout.assign(value);
    setbuts;
    invalidate;
  end;
end;

procedure TAHMImage.setcenter(value : Boolean);
begin
  fcenter:=value;
  invalidate;
end;

procedure TAHMImage.setform(value : Boolean);
begin
  if value<>f3dform then
  begin
    f3dform:=value;
    setbuts;    
    invalidate;
  end;
end;

procedure TAHMImage.setint(value : Integer);
begin
  if (value >-1) and (value <201) then
  if value <> fint then
  begin
    fint:=value;
    setbuts;
    invalidate;
  end;
end;

procedure TAHMImage.setborder(value : Integer);
begin
  if (value >0) then
  if value <> fint then
  begin
    fborder:=value;
    setbuts;
    invalidate;
  end;
end;

end.
