(************************************************************************
*    This File is Part of the AHM Triton Tools                          *
*    for Borland Delphi and C++ Builder.                                *
*************************************************************************
* Copyright  1995-2000 Alexander H. Mehlhorn (AHM) and Tritontools.com *
* All Rights reserved.                                                  *
*                                                                       *
*    For more Information contact us at                                 *
*    E-Mail : support@tritontools.com                                   *
*    URL : http://www.tritontools.com                                   *
*                                                                       *
*    AHM is copyright by Alexander H. Mehlhorn                          *
*    All Parts of this Collection were developed,                       *
*    designed and implemented by AHM                                    *
*                                                                       *
*    Under no Circumstances may you distribute this file                *
*    in this or any other format. This File is supplied                 *
*    as Evaluation of Source only. No Delphi Components may be developed*
*    using extracts or subsets of this code without expressed permission*
*    by AHM.                                                            *
*                                                                       *
*************************************************************************)
unit AHMTQuickInfo;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls,AHMFreeware;

type
  TAHMQuickInfoForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    BitBtn1: TBitBtn;
    Bevel1: TBevel;
    StatusBar1: TStatusBar;
    procedure BitBtn1Click(Sender: TObject);
  private
  public
  end;
type
  TAHMQuickInfo = class(TComponent)
  private
    FAbout : TAHMAboutFreeStr;
     fl1,fl2,fl3,fl4,fl5,
     fl6,fl7,fl8,fl9,fl10 : String;
     ffon : TFont;
     fx : TAlignment;
     fcap : String;
     Procedure Setfon(value : Tfont);
  public
    constructor Create(AOwner:TComponent); override;
    destructor Destroy; override;
    Function Execute : Boolean;
  published
    Property About : TAHMAboutFreeStr read FAbout write FAbout;
    Property Alignment : TAlignment read fx write fx;
    Property Line1 : String read fl1 write fl1;
    Property Line2 : String read fl2 write fl2;
    Property Line3 : String read fl3 write fl3;
    Property Line4 : String read fl4 write fl4;
    Property Line5 : String read fl5 write fl5;
    Property Line6 : String read fl6 write fl6;
    Property Line7 : String read fl7 write fl7;
    Property Line8 : String read fl8 write fl8;
    Property Line9 : String read fl9 write fl9;
    Property Line10 : String read fl10 write fl10;
    Property InfoboxCaption : String read fcap write fcap;
    Property Fonts : TFont read ffon write Setfon;
  end;

implementation
{$R *.DFM}

Function TAHMQuickInfo.Execute : Boolean;
var i : integer;
    AHMInfoForm : TAHMQuickInfoForm;
begin
  AHMInfoForm:=TAHMQuickInfoForm.create(Application);
  try
    AHMInfoForm.caption:=fcap;
    with AHMInfoForm do
    for I := 0 to ComponentCount -1 do
    begin
      if Components[I] is TLabel then
      begin
        TLabel(Components[I]).Alignment := fx;
        TLabel(Components[I]).font:=ffon;
      end;
      if Components[I] is TBitbtn then TBitbtn(Components[I]).font:=ffon;
    end;
    AHMInfoForm.label1.caption:= fl1;
    AHMInfoForm.label2.caption:= fl2;
    AHMInfoForm.label3.caption:= fl3;
    AHMInfoForm.label4.caption:= fl4;
    AHMInfoForm.label5.caption:= fl5;
    AHMInfoForm.label6.caption:= fl6;
    AHMInfoForm.label7.caption:= fl7;
    AHMInfoForm.label8.caption:= fl8;
    AHMInfoForm.label9.caption:= fl9;
    AHMInfoForm.label10.caption:= fl10;
    AHMInfoForm.showmodal;
  finally
    AHMInfoForm.free;
  end;
  result:=true;
end;

constructor TAHMQuickInfo.Create(AOwner:TComponent);
begin
  fcap:='Quick Information Box';
  ffon := TFont.create;
  fl1:='THE TQUICKINFO COMPONENT V 2.0';
  fl2:='written';
  fl3:='16 - July 1996';
  fl4:='by';
  fl5:='Alexander Mehlhorn';
  fl6:='for all those People out there';
  fl7:='who want to be able to supply ';
  fl8:='some kind of info to all kind';
  fl9:='of programs ...';
  fl10:='Copyright @1996 by AHM';
  fx:=taCenter;
  inherited Create(AOwner);
end;


destructor TAHMQuickInfo.Destroy;
begin
  ffon.free;
  inherited Destroy;
end;

Procedure TAHMQuickInfo.Setfon(value : TFont);
begin
  ffon.assign(value);
end;

procedure TAHMQuickInfoForm.BitBtn1Click(Sender: TObject);
begin
  close;
end;

end.
